﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ConnectionDefinition
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            diagra.EnterKeyBehavior = Infragistics.Controls.Charts.EnterKeyBehavior.CommitChanges;
        }
    }

    //Add the data items 
    public class WaterFlowViewModel : INotifyPropertyChanged
    {
        public WaterFlowViewModel()
        {
            Activities = new ObservableCollection<Activity>()
        {
            new Activity("Requirements"),
            new Activity("Design"),
            new Activity("Construction"),
            new Activity("Integration"),
            new Activity("Testing"),
            new Activity("Installation"),
            new Activity("Maintenance")
        };

            Relations = new ObservableCollection<ActivityRelation>()
        {
            new ActivityRelation("Requirements", "Design"),
            new ActivityRelation("Design", "Construction"),
            new ActivityRelation("Construction", "Integration"),
            new ActivityRelation("Integration", "Testing"),
            new ActivityRelation("Testing", "Installation"),
            new ActivityRelation("Installation", "Maintenance"),
        };
        }

        private IList<Activity> _activities;
        public IList<Activity> Activities
        {
            get { return _activities; }
            set
            {
                _activities = value;
                OnPropertyChanged();
            }
        }

        private IList<ActivityRelation> _relations;
        public IList<ActivityRelation> Relations
        {
            get { return _relations; }

            set
            {
                _relations = value;
                OnPropertyChanged();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }                      
    //Add the sample connection class 
    public class ActivityRelation : INotifyPropertyChanged
    {
        public ActivityRelation(string from, string to)
        {
            StartKey = from;
            EndKey = to;
        }

        private string _startKey;
        public string StartKey
        {
            get { return _startKey; }
            set
            {
                _startKey = value;
                OnPropertyChanged();
            }
        }

        private string _endKey;
        public string EndKey
        {
            get { return _endKey; }
            set
            {
                _endKey = value;
                OnPropertyChanged();
            }
        }


        public override string ToString()
        {
            return "";
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    //Add the sample node data class 
    public class Activity : INotifyPropertyChanged
    {
        public Activity(string name) { Key = name; }

        private string _key;
        public string Key
        {
            get { return _key; }
            set
            {
                _key = value;
                OnPropertyChanged();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

}
